import * as CodeGenerator from '@alilc/lowcode-code-generator/standalone-loader';
import type { ILowCodePluginContext } from '@alilc/lowcode-engine';
export interface ICodeGenPlugin {
    generateCode: typeof CodeGenerator.generateCode;
}
export declare type CodeGenPluginOptions = {
    /** 是否要禁用出码的动作按钮(默认: 否) */
    disableCodeGenActionBtn?: boolean;
};
declare const codeGeneratorPlugin: {
    (ctx: ILowCodePluginContext, options?: CodeGenPluginOptions): {
        exports(): {
            generateCode: typeof CodeGenerator.generateCode;
        };
        init(): Promise<void>;
        destroy(): void;
    };
    pluginName: string;
    meta: {
        dependencies: any[];
    };
};
export default codeGeneratorPlugin;
